
/*

MIDI Lighting for keyboard and MIDI song files
Written by Perry Scanlon, Version 2018-10-05
Videos and instructions at Lights4Music.com

You are free to use this code as you wish.  If you create derivative code and release publicly, or if you use in a commercial product, please give credit for the use of this code.  
For full license details, see license.txt contained in this code release.

Tested with Teensy 3.2 and should work with Teensy LC if you don't need much buffering.  To use with multi-track songs or fast songs with a synthesizer that has a lot of audio latency, the Teensy 3.2 is a better choice because it has more RAM.  This code, in it's current form, does not use RAM efficiently for buffering.  A future release will use less RAM and work better with Teensy LC.

This is intended for a single track, but in many cases it will work fine with multi-track songs, depending on how the overlapping occurs of simultaneous notes of the same pitch.
To write a better program for multi-track songs, you can run similar code for every track and then mix them together using greatest RGB values.  This will greatly increase RAM usage, especially with the current buffering method.

Adjust the values in the a_global tab to customize your light show.

To fine-tune the fade-off times, you can use division instead of bit-shifting and not notice the additional computation time on a 32-bit processor.  Future code releases will use division.

To use 5-pin (DIN) MIDI instead of USB MIDI, see 5-pin MIDI code and circuits at http://lights4music.com/instructions.html

*/

