
// The spacing of hues is based on opponent process color theory rather than trichromatic color theory.  Exact colors will depend on the wavelength distributions of the LED's and to a small degree, the dimming circuit.
// Transition between component colors (R, G, B) is nonlinear and uses the same curve as the dimming curve.

byte HB2red (unsigned int hue, byte brightness_value)
{
 
 if (hue < 1024)
 {
  return brightness_value;
 }

 if ((hue > 1023) && (hue < 2048))
 {
  return (byte)((brightness_value * curve[255 - ((hue - 1024) >> 2)]) >> 8);
 }
 
 if ((hue > 2047) && (hue < 2560))
 {
  return 0;
 }

 if ((hue > 2559) && (hue < 3072))
 {
  return 0;
 }

 if ((hue > 3071) && (hue < 3584))
 {
  return (byte)((brightness_value * curve[(hue - 3072) >> 1]) >> 8);
 }
 
 if ((hue > 3583) && (hue < 4096))
 {
  return brightness_value;
 }

 return 0;
 
}


byte HB2green (unsigned int hue, byte brightness_value)
{
  
 if (hue < 1024)
 {
  return (byte)((brightness_value * curve[hue >> 2]) >> 8);
 }

 if ((hue > 1023) && (hue < 2048))
 {
  return brightness_value;
 }
 
 if ((hue > 2047) && (hue < 2560))
 {
  return brightness_value;
 }

 if ((hue > 2559) && (hue < 3072))
 {
  return (byte)((brightness_value * curve[255 - ((hue - 2560) >> 1)]) >> 8);
 }

 if ((hue > 3071) && (hue < 3584))
 {
  return 0;
 }
 
 if ((hue > 3583) && (hue < 4096))
 {
  return 0;
 }

 return 0;
 
}


byte HB2blue (unsigned int hue, byte brightness_value)
{
  
 if (hue < 1024)
 {
  return 0;
 }

 if ((hue > 1023) && (hue < 2048))
 {
  return 0;
 }
 
 if ((hue > 2047) && (hue < 2560))
 {
  return (byte)((brightness_value * curve[(hue - 2048) >> 1]) >> 8);
 }

 if ((hue > 2559) && (hue < 3072))
 {
  return brightness_value;
 }

 if ((hue > 3071) && (hue < 3584))
 {
  return brightness_value;
 }
 
 if ((hue > 3583) && (hue < 4096))
 {
  return (byte)((brightness_value * curve[255 - ((hue - 3584) >> 1)]) >> 8);
 }

 return 0;
 
}


